## mingw-w64-orcus-0.19.2-5.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
cmake_policy(SET CMP0048 NEW)

set(ORCUS_MAJOR_VERSION 0)
set(ORCUS_MINOR_VERSION 19)
set(ORCUS_MICRO_VERSION 2)
set(ORCUS_MAJOR_API_VERSION 0)
set(ORCUS_MINOR_API_VERSION 18)
set(ORCUS_VERSION ${ORCUS_MAJOR_VERSION}.${ORCUS_MINOR_VERSION}.${ORCUS_MICRO_VERSION})
set(ORCUS_API_VERSION ${ORCUS_MAJOR_API_VERSION}.${ORCUS_MINOR_API_VERSION})

project(orcus VERSION ${ORCUS_VERSION} LANGUAGES CXX)
set(CMAKE_CXX_STANDARD 17)

set(MDDS_INCLUDEDIR "" CACHE STRING "path to mdds header directory.")
set(IXION_INCLUDEDIR "" CACHE STRING "path to ixion header directory.")
set(IXION_LIBRARYDIR "" CACHE STRING "path to ixion library directory.")
option(ORCUS_WITH_CPU_FEATURES "whether or not to enable use of CPU extensions.")
option(ORCUS_WITH_SSE42 "whether or not to enable use of SSE 4.2.")
option(ORCUS_WITH_AVX2 "whether or not to enable use of AVX2.")
option(ORCUS_WITH_PARQUET "whether or not to enable support for Apache Parquet import filter.")

find_package(Boost COMPONENTS program_options filesystem)
find_package(Threads)
find_package(Python3)
find_package(ZLIB)

include(GNUInstallDirs)

enable_testing()
set(CMAKE_CTEST_COMMAND ctest)

add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})

find_library(IXION_LIB ixion-0.18 PATHS ${IXION_LIBRARYDIR})

if(NOT IXION_LIB)
    message(FATAL_ERROR "Ixion not found.")
endif()

message(STATUS "Found Ixion: ${IXION_LIB}")

if(MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4251 /wd4275 /wd4267 /wd4244 /MP")
    add_definitions(
        -D_CRT_SECURE_NO_WARNINGS
    )
endif(MSVC)

add_definitions(
    ${Boost_LIB_DIAGNOSTIC_DEFINITIONS}
)

if(ORCUS_WITH_CPU_FEATURES)
    add_definitions(-D__ORCUS_CPU_FEATURES)
    message(STATUS "Enabling use of CPU features...")

    if(ORCUS_WITH_AVX2)
        message(STATUS "Enabling AVX2...")
        if(MSVC)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /arch:AVX2")
        else()
            add_definitions(-D__AVX2__)
        endif()
    endif()

    if(ORCUS_WITH_SSE42)
        message(STATUS "Enabling SSE 4.2...")
        add_definitions(-D__SSE4_2__)
    endif()

endif()

if(ORCUS_WITH_PARQUET)
    find_package(Parquet)
endif()

include_directories(
    ${PROJECT_SOURCE_DIR}/include
    ${PROJECT_SOURCE_DIR}/src/include
    ${Boost_INCLUDE_DIR}
    ${MDDS_INCLUDEDIR}
    ${IXION_INCLUDEDIR}
    ${ZLIB_INCLUDE_DIRS}
)

link_directories(${Boost_LIBRARY_DIRS})

add_subdirectory(include)
add_subdirectory(src)

=== cmake-csv/CMakeLists.txt ===
# Custom cmake configuration only to build the CSV parser portion of orcus.

cmake_minimum_required(VERSION 2.8)
cmake_policy(SET CMP0048 NEW)

set(ORCUS_MAJOR_VERSION 0)
set(ORCUS_MINOR_VERSION 13)
set(ORCUS_MICRO_VERSION 99)
set(ORCUS_VERSION ${ORCUS_MAJOR_VERSION}.${ORCUS_MINOR_VERSION}.${ORCUS_MICRO_VERSION})

project(orcus VERSION ${ORCUS_VERSION} LANGUAGES CXX)
set(CMAKE_CXX_STANDARD 11)

if(MSVC)
    set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} /wd4251 /wd4275 /MP")
endif(MSVC)

include_directories(
    ${PROJECT_SOURCE_DIR}/../include
)

set(PARSER_SRC_DIR ${PROJECT_SOURCE_DIR}/../src/parser)

add_library(liborcus-parser-csv SHARED
    ${PARSER_SRC_DIR}/parser_base.cpp
    ${PARSER_SRC_DIR}/parser_global.cpp
    ${PARSER_SRC_DIR}/csv_parser_base.cpp
    ${PARSER_SRC_DIR}/exception.cpp
    ${PARSER_SRC_DIR}/cell_buffer.cpp
)

target_compile_definitions(liborcus-parser-csv PRIVATE __ORCUS_PSR_BUILDING_DLL)

=== include/CMakeLists.txt ===
add_subdirectory(orcus)

=== src/CMakeLists.txt ===

add_subdirectory(test)
add_subdirectory(parser)
add_subdirectory(liborcus)
add_subdirectory(spreadsheet)

add_executable(orcus-detect
    orcus_detect_main.cpp
)

add_executable(orcus-css-dump
    orcus_css_dump.cpp
)

add_executable(orcus-zip-dump
    orcus_zip_dump.cpp
)

add_executable(orcus-json
    cli_global.cpp
    orcus_json_cli.cpp
    orcus_json_cli_map.cpp
)

add_executable(orcus-yaml
    orcus_yaml_main.cpp
)

add_executable(orcus-csv
    orcus_csv_main.cpp
    orcus_filter_global.cpp
)

add_executable(orcus-xml
    orcus_xml_main.cpp
    cli_global.cpp
    orcus_filter_global.cpp
)

add_executable(orcus-ods
    orcus_ods_main.cpp
    orcus_filter_global.cpp
)

add_executable(orcus-styles-ods
    orcus_ods_styles.cpp
    orcus_filter_global.cpp
)

add_executable(orcus-xlsx
    orcus_xlsx_main.cpp
    orcus_filter_global.cpp
)

add_executable(orcus-xls-xml
    orcus_xls_xml_main.cpp
    orcus_filter_global.cpp
)

target_link_libraries(orcus-detect orcus-${ORCUS_API_VERSION})
target_link_libraries(orcus-css-dump orcus-parser-${ORCUS_API_VERSION} orcus-${ORCUS_API_VERSION})
target_link_libraries(orcus-zip-dump orcus-parser-${ORCUS_API_VERSION})
target_link_libraries(orcus-json orcus-parser-${ORCUS_API_VERSION} orcus-${ORCUS_API_VERSION})
target_link_libraries(orcus-yaml orcus-parser-${ORCUS_API_VERSION} orcus-${ORCUS_API_VERSION})
target_link_libraries(orcus-csv orcus-parser-${ORCUS_API_VERSION} orcus-spreadsheet-model-${ORCUS_API_VERSION} orcus-${ORCUS_API_VERSION})
target_link_libraries(orcus-xml orcus-parser-${ORCUS_API_VERSION} orcus-spreadsheet-model-${ORCUS_API_VERSION} orcus-${ORCUS_API_VERSION})
target_link_libraries(orcus-ods orcus-parser-${ORCUS_API_VERSION} orcus-spreadsheet-model-${ORCUS_API_VERSION} orcus-${ORCUS_API_VERSION})
target_link_libraries(orcus-styles-ods orcus-parser-${ORCUS_API_VERSION} orcus-spreadsheet-model-${ORCUS_API_VERSION} orcus-${ORCUS_API_VERSION})
target_link_libraries(orcus-xlsx orcus-parser-${ORCUS_API_VERSION} orcus-spreadsheet-model-${ORCUS_API_VERSION} orcus-${ORCUS_API_VERSION})
target_link_libraries(orcus-xls-xml orcus-parser-${ORCUS_API_VERSION} orcus-spreadsheet-model-${ORCUS_API_VERSION} orcus-${ORCUS_API_VERSION})

add_executable(orcus-env-dump EXCLUDE_FROM_ALL
    orcus_env_dump.cpp
)

target_link_libraries(orcus-env-dump orcus-parser-${ORCUS_API_VERSION} orcus-${ORCUS_API_VERSION})

# test programs

add_executable(orcus-test-csv EXCLUDE_FROM_ALL
    orcus_test_csv.cpp
    orcus_test_global.cpp
)

add_executable(orcus-test-ods EXCLUDE_FROM_ALL
    orcus_test_ods.cpp
)

add_executable(orcus-test-xls-xml EXCLUDE_FROM_ALL
    orcus_test_xls_xml.cpp
    orcus_test_global.cpp
)

add_executable(orcus-test-xlsx EXCLUDE_FROM_ALL
    orcus_test_xlsx.cpp
)

add_executable(orcus-test-xml EXCLUDE_FROM_ALL
    orcus_test_xml.cpp
)

add_executable(orcus-test-xml-mapped EXCLUDE_FROM_ALL
    orcus_test_xml_mapped.cpp
    orcus_test_global.cpp
)

add_executable(orcus-test-json-mapped EXCLUDE_FROM_ALL
    orcus_test_json_mapped.cpp
)

add_executable(orcus-test-import-ods EXCLUDE_FROM_ALL
    orcus_test_import_ods.cpp
)

list(APPEND _TESTS
    orcus-test-csv
    orcus-test-ods
    orcus-test-xls-xml
    orcus-test-xlsx
    orcus-test-xml
    orcus-test-xml-mapped
    orcus-test-json-mapped
    orcus-test-import-ods
)

list(APPEND _INSTALL_TARGETS
    orcus-detect
    orcus-css-dump
    orcus-zip-dump
    orcus-json
    orcus-yaml
    orcus-csv
    orcus-xml
    orcus-ods
    orcus-styles-ods
    orcus-xlsx
    orcus-xls-xml
)

if(ORCUS_WITH_PARQUET)
    add_executable(orcus-parquet
        orcus_parquet_main.cpp
        orcus_filter_global.cpp
    )
    target_link_libraries(orcus-parquet
        orcus-parser-${ORCUS_API_VERSION}
        orcus-spreadsheet-model-${ORCUS_API_VERSION}
        orcus-${ORCUS_API_VERSION}
    )
    list(APPEND _INSTALL_TARGETS orcus-parquet)

    add_executable(orcus-test-parquet EXCLUDE_FROM_ALL orcus_test_parquet.cpp)
    list(APPEND _TESTS orcus-test-parquet)
endif()

foreach(_TEST ${_TESTS})
    target_link_libraries(${_TEST}
        orcus-parser-${ORCUS_API_VERSION}
        orcus-spreadsheet-model-${ORCUS_API_VERSION}
        orcus-${ORCUS_API_VERSION}
        orcus-test
    )

    target_compile_definitions(${_TEST} PRIVATE
        SRCDIR="${PROJECT_SOURCE_DIR}"
    )

    add_test(${_TEST} ${_TEST})

    # Make sure the liborcus-parser library file is present in the same directory
    # as the test program.
    add_custom_command(TARGET ${_TEST} POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E copy_if_different
        $<TARGET_FILE:orcus-parser-${ORCUS_API_VERSION}>
        $<TARGET_FILE:orcus-${ORCUS_API_VERSION}>
        $<TARGET_FILE:orcus-spreadsheet-model-${ORCUS_API_VERSION}>
        $<TARGET_FILE_DIR:${_TEST}>
    )
endforeach()

add_dependencies(check ${_TESTS})

install(
    TARGETS ${_INSTALL_TARGETS}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

=== src/liborcus/CMakeLists.txt ===

list(APPEND _SOURCES
# core
    config.cpp
    css_document_tree.cpp
    css_selector.cpp
    detection_result.cpp
    dom_tree.cpp
    format_detection.cpp
    formula_result.cpp
    info.cpp
    interface.cpp
    json_document_tree.cpp
    json_map_tree.cpp
    json_structure_mapper.cpp
    json_structure_tree.cpp
    json_util.cpp
    spreadsheet_interface.cpp
    orcus_csv.cpp
    orcus_json.cpp
    orcus_xml.cpp
    orcus_xml_impl.cpp
    orcus_xml_map_def.cpp
    measurement.cpp
    number_utils.cpp
    xml_context_base.cpp
    xml_context_global.cpp
    xml_element_types.cpp
    xml_element_validator.cpp
    xml_empty_context.cpp
    xml_map_tree.cpp
    xml_stream_handler.cpp
    xml_stream_parser.hpp
    xml_stream_parser.cpp
    xml_simple_stream_handler.cpp
    xml_structure_mapper.cpp
    xml_structure_tree.cpp
    xml_util.cpp
    xpath_parser.cpp
    yaml_document_tree.cpp
    ooxml_namespace_types.cpp
    ooxml_namespace_types.hpp
    odf_namespace_types.hpp
    odf_namespace_types.cpp
    gnumeric_namespace_types.cpp
    xls_xml_namespace_types.cpp
    session_context.cpp
    spreadsheet_interface.cpp
    spreadsheet_iface_util.cpp
    spreadsheet_types.cpp
    spreadsheet_impl_types.cpp
    string_helper.cpp
# xlsx filter
    ooxml_content_types.cpp
    ooxml_global.cpp
    ooxml_schemas.cpp
    ooxml_tokens.cpp
    ooxml_types.cpp
    opc_context.cpp
    opc_reader.cpp
    orcus_xlsx.cpp
    orcus_import_xlsx.cpp
    xlsx_shared_strings_context.cpp
    xlsx_drawing_context.cpp
    xlsx_handler.cpp
    xlsx_helper.cpp
    xlsx_session_data.cpp
    xlsx_styles_context.cpp
    xlsx_revision_context.cpp
    xlsx_pivot_context.cpp
    xlsx_sheet_context.cpp
    xlsx_conditional_format_context.cpp
    xlsx_table_context.cpp
    xlsx_autofilter_context.cpp
    xlsx_types.cpp
    xlsx_workbook_context.cpp
# xls-xml filter
    xls_xml_tokens.cpp
    orcus_xls_xml.cpp
    xls_xml_detection_handler.cpp
    xls_xml_handler.cpp
    xls_xml_context.cpp
# ods filter
    odf_document_styles_context.cpp
    odf_para_context.cpp
    odf_styles.cpp
    odf_styles_context.cpp
    odf_style_context.cpp
    odf_number_format_context.cpp
    odf_tokens.cpp
    ods_content_xml_context.cpp
    ods_dde_links_context.cpp
    ods_session_data.cpp
    odf_helper.cpp
    orcus_ods.cpp
    orcus_import_ods.cpp
# gnumeric filter
# TODO : document a way to build boost with bzip2 and zlib options, or find
# a way to make this a build-time option.
#   gnumeric_detection_handler.cpp
#   gnumeric_cell_context.cpp
#   gnumeric_filter_context.cpp
#   gnumeric_context.cpp
#   gnumeric_handler.cpp
#   gnumeric_sheet_context.cpp
#   gnumeric_styles_context.cpp
#   gnumeric_names_context.cpp
#   gnumeric_tokens.cpp
#   gnumeric_types.cpp
#   gnumeric_value_format_parser.cpp
#   orcus_gnumeric.cpp
)

list(APPEND _COMPILE_DEFS
    __ORCUS_BUILDING_DLL
    __ORCUS_XLSX
    __ORCUS_ODS
    __ORCUS_XLS_XML
)

list(APPEND _LINK_LIBS
    orcus-parser-${ORCUS_API_VERSION}
)

if(ORCUS_WITH_PARQUET)
    list(APPEND _SOURCES orcus_parquet.cpp)
    list(APPEND _COMPILE_DEFS __ORCUS_PARQUET)
    list(APPEND _LINK_LIBS Parquet::parquet_shared)
endif()

add_library(orcus-${ORCUS_API_VERSION} SHARED ${_SOURCES})

configure_file(constants.inl.in ${CMAKE_CURRENT_BINARY_DIR}/constants.inl)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

target_link_libraries(orcus-${ORCUS_API_VERSION} ${_LINK_LIBS})

target_compile_definitions(orcus-${ORCUS_API_VERSION} PRIVATE ${_COMPILE_DEFS})

# single-file test programs

set(_TESTS
    common-test
    css-document-tree-test
    dom-tree-test
#   gnumeric-cell-context-test
#   gnumeric-sheet-context-test
    json-document-tree-test
    json-structure-tree-test
    xml-structure-tree-test
    yaml-document-tree-test
)

foreach(_TEST ${_TESTS})
    set(_TEST_FILE ${_TEST}.cpp)
    string(REPLACE "-" "_" _TEST_FILE ${_TEST_FILE})
    add_executable(${_TEST} EXCLUDE_FROM_ALL ${_TEST_FILE})
    target_link_libraries(${_TEST}
        orcus-${ORCUS_API_VERSION}
        orcus-parser-${ORCUS_API_VERSION}
        orcus-test
    )
    target_compile_definitions(${_TEST} PRIVATE
        SRCDIR="${PROJECT_SOURCE_DIR}"
    )
    add_test(${_TEST} ${_TEST})

    # Make sure the orcus-parser library file is present in the same directory
    # as the test program.
    add_custom_command(TARGET ${_TEST} POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E copy_if_different
        $<TARGET_FILE:orcus-parser-${ORCUS_API_VERSION}>
        $<TARGET_FILE_DIR:${_TEST}>
    )

endforeach()

# multi-file test programs

add_executable(odf-helper-test EXCLUDE_FROM_ALL
    odf_helper_test.cpp
    odf_helper.cpp
    string_helper.cpp
)

add_executable(xlsx-sheet-context-test EXCLUDE_FROM_ALL
    formula_result.cpp
    ooxml_global.cpp
    ooxml_namespace_types.cpp
    ooxml_schemas.cpp
    ooxml_tokens.cpp
    ooxml_types.cpp
    session_context.cpp
    xlsx_autofilter_context.cpp
    xlsx_conditional_format_context.cpp
    xlsx_helper.cpp
    xlsx_session_data.cpp
    xlsx_sheet_context.cpp
    xlsx_sheet_context_test.cpp
    xlsx_types.cpp
    xml_context_base.cpp
    xml_context_global.cpp
    xml_element_types.cpp
    xml_element_validator.cpp
    xml_empty_context.cpp
    xml_util.cpp
)

add_executable(xml-map-tree-test EXCLUDE_FROM_ALL
    xml_map_tree_test.cpp
    spreadsheet_impl_types.cpp
    xml_map_tree.cpp
    xpath_parser.cpp
)

add_executable(json-map-tree-test EXCLUDE_FROM_ALL
    json_map_tree_test.cpp
    json_map_tree.cpp
    spreadsheet_impl_types.cpp
)

add_executable(xpath-parser-test EXCLUDE_FROM_ALL
    xpath_parser_test.cpp
    xpath_parser.cpp
)

target_compile_definitions(xlsx-sheet-context-test PRIVATE
    __ORCUS_STATIC_LIB
)

target_link_libraries(odf-helper-test orcus-${ORCUS_API_VERSION} orcus-parser-${ORCUS_API_VERSION})
target_link_libraries(xlsx-sheet-context-test orcus-${ORCUS_API_VERSION} orcus-parser-${ORCUS_API_VERSION} orcus-test)
target_link_libraries(xml-map-tree-test orcus-${ORCUS_API_VERSION} orcus-parser-${ORCUS_API_VERSION} orcus-test)
target_link_libraries(json-map-tree-test orcus-${ORCUS_API_VERSION} orcus-parser-${ORCUS_API_VERSION})
target_link_libraries(xpath-parser-test orcus-${ORCUS_API_VERSION} orcus-parser-${ORCUS_API_VERSION})
add_test(odf-helper-test odf-helper-test)
add_test(xlsx-sheet-context-test xlsx-sheet-context-test)
add_test(xml-map-tree-test xml-map-tree-test)

add_dependencies(check
    ${_TESTS}
    odf-helper-test
    xlsx-sheet-context-test
    xml-map-tree-test
    json-map-tree-test
    xpath-parser-test
)

install(
    TARGETS
        orcus-${ORCUS_API_VERSION}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

=== src/parser/CMakeLists.txt ===

add_library(orcus-parser-${ORCUS_API_VERSION} SHARED
    base64.cpp
    cell_buffer.cpp
    css_parser_base.cpp
    css_types.cpp
    csv_parser_base.cpp
    exception.cpp
    json_global.cpp
    json_parser_base.cpp
    json_parser_thread.cpp
    parser_base.cpp
    parser_global.cpp
    sax_parser_base.cpp
    sax_token_parser.cpp
    sax_token_parser_thread.cpp
    stream.cpp
    string_pool.cpp
    tokens.cpp
    types.cpp
    utf8.cpp
    xml_namespace.cpp
    xml_writer.cpp
    yaml_parser_base.cpp
    zip_archive.cpp
    zip_archive_stream.cpp
)

target_compile_definitions(orcus-parser-${ORCUS_API_VERSION} PRIVATE
    __ORCUS_PSR_BUILDING_DLL
    _SILENCE_CXX17_CODECVT_HEADER_DEPRECATION_WARNING
)
target_link_libraries(orcus-parser-${ORCUS_API_VERSION} ${ZLIB_LIBRARIES})

# test programs

set(_TESTS
    base64-test
    css-parser-test
    csv-parser-test
    json-parser-test
    parser-base-test
    parser-global-test
    sax-ns-parser-test
    sax-parser-test
    sax-token-parser-test
    stream-test
    string-pool-test
    threaded-json-parser-test
    threaded-sax-token-parser-test
    types-test
    xml-namespace-test
    xml-writer-test
    yaml-parser-test
    zip-archive-test
)

foreach(_TEST ${_TESTS})
    set(_TEST_FILE ${_TEST}.cpp)
    string(REPLACE "-" "_" _TEST_FILE ${_TEST_FILE})
    add_executable(${_TEST} EXCLUDE_FROM_ALL ${_TEST_FILE})
    target_link_libraries(${_TEST}
        orcus-parser-${ORCUS_API_VERSION}
        orcus-test
    )

    target_compile_definitions(${_TEST} PRIVATE
        SRCDIR="${PROJECT_SOURCE_DIR}"
    )

    add_test(${_TEST} ${_TEST})
endforeach()

add_dependencies(check ${_TESTS})

# utf8-test

add_executable(utf8-test utf8.cpp utf8_test.cpp)
target_link_libraries(utf8-test orcus-parser-${ORCUS_API_VERSION})
add_test(utf8-test utf8-test)
add_dependencies(check utf8-test)

install(
    TARGETS
        orcus-parser-${ORCUS_API_VERSION}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

=== src/spreadsheet/CMakeLists.txt ===

add_library(orcus-spreadsheet-model-${ORCUS_API_VERSION} SHARED
    auto_filter.cpp
    check_dumper.cpp
    config.cpp
    csv_dumper.cpp
    debug_state_dumper.cpp
    document.cpp
    document_impl.cpp
    document_types.cpp
    dumper_global.cpp
    factory.cpp
    factory_pivot.cpp
    factory_shared_strings.cpp
    factory_sheet.cpp
    factory_styles.cpp
    factory_table.cpp
    flat_dumper.cpp
    formula_global.cpp
    global_settings.cpp
    html_dumper.cpp
    json_dumper.cpp
    number_format.cpp
    pivot.cpp
    shared_formula.cpp
    shared_strings.cpp
    sheet.cpp
    sheet_impl.cpp
    styles.cpp
    view.cpp
)

target_link_libraries(orcus-spreadsheet-model-${ORCUS_API_VERSION} orcus-parser-${ORCUS_API_VERSION} orcus-${ORCUS_API_VERSION} ${IXION_LIB})
target_compile_definitions(orcus-spreadsheet-model-${ORCUS_API_VERSION} PRIVATE __ORCUS_SPM_BUILDING_DLL)

install(
    TARGETS
        orcus-spreadsheet-model-${ORCUS_API_VERSION}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

=== src/test/CMakeLists.txt ===

add_library(orcus-test STATIC test_global.cpp mock_spreadsheet.cpp)

=== include/orcus/spreadsheet/CMakeLists.txt ===

list(APPEND _HEADERS
    auto_filter.hpp
    config.hpp
    document.hpp
    document_types.hpp
    export_interface.hpp
    factory.hpp
    import_interface.hpp
    import_interface_pivot.hpp
    import_interface_styles.hpp
    import_interface_view.hpp
    pivot.hpp
    shared_strings.hpp
    sheet.hpp
    styles.hpp
    types.hpp
    view.hpp
    view_types.hpp
)

install(FILES ${_HEADERS}
    DESTINATION include/orcus-${ORCUS_API_VERSION}/orcus/spreadsheet
)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=orcus
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=0.19.2
pkgrel=5
pkgdesc="Standalone file import filter library for spreadsheet documents (ODS, XLSX and CSV). (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url='https://gitlab.com/orcus/orcus'
msys2_references=(
  'archlinux: liborcus'
)
license=('spdx:MPL-2.0')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-boost-libs"
         "${MINGW_PACKAGE_PREFIX}-ixion"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-autotools"
             "${MINGW_PACKAGE_PREFIX}-boost"
             "${MINGW_PACKAGE_PREFIX}-mdds"
             "${MINGW_PACKAGE_PREFIX}-python")
optdepends=("${MINGW_PACKAGE_PREFIX}-python: Python bindings")
source=("https://gitlab.com/orcus/orcus/-/archive/${pkgver}/${_realname}-${pkgver}.tar.bz2"
        "001-fix-build-on-mingw.patch"
        "002-workaround-for-gcc.patch"
        "003-do-not-search-for-boost-system.patch")
sha256sums=('d5e443bc5dbfd2271eee792bbd7048bc3675da41007b0c410e9c8dca56433638'
            '1b86bbb84e69f5ea0d5de766537acc5108f299b2a3cfa1732341c9bd2eb32d41'
            'd2b76a347e6f8bfd09ef104aa1abd7add59b5ec108df65db7a562f248311d30c'
            '112f73f7695e9963913cd21f5245391529101a660a8f3b3fff805fb4958d5d21')

prepare() {
  cd ${_realname}-${pkgver}
  patch -p1 -i "${srcdir}"/001-fix-build-on-mingw.patch
  patch -p1 -i "${srcdir}"/003-do-not-search-for-boost-system.patch

  if [[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]]; then
    patch -p1 -i "${srcdir}"/002-workaround-for-gcc.patch
  fi

  autoreconf -fiv
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  export lt_cv_deplibs_check_method='pass_all'

  declare -a _extra_config
  if [[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]]; then
    _extra_config+=("--disable-spreadsheet-model" "--disable-python")
  fi

  if [[ ${CARCH} == x86_64 ]]; then
    _extra_config+=("--with-cpu-features")
  fi

  ../${_realname}-${pkgver}/configure \
    --prefix=${MINGW_PREFIX} \
    --without-benchmark \
    "${_extra_config[@]}"

  make
}

check() {
  cd "${srcdir}/build-${MSYSTEM}"

  make check || true
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" make install

  MSYS2_ARG_CONV_EXCL="-p" python -m compileall \
    -o 0 -o 1 -q -s"${pkgdir}" -p"/" "${pkgdir}${MINGW_PREFIX}/lib/python"*

  PREFIX_WIN=$(cygpath -wm ${MINGW_PREFIX})
  find "${pkgdir}${MINGW_PREFIX}/lib/pkgconfig" -type f -name '*.pc' \
    -exec sed -i -e "s|${PREFIX_WIN}|\$\{prefix\}|g" {} \;

  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    _pyver=$(${MINGW_PREFIX}/bin/python -c "import sys;sys.stdout.write('.'.join(map(str, sys.version_info[:2])))")
    # Use *.pyd extension for python modules
    for _dll in "${pkgdir}${MINGW_PREFIX}"/lib/python${_pyver}/site-packages/*.dll; do
      mv ${_dll} ${_dll/.dll/.pyd}
    done
    # remove unused import libraries
    rm -f "${pkgdir}${MINGW_PREFIX}"/lib/python${_pyver}/site-packages/*.dll.a
  fi

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/LICENSE" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
